C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.8 [06-Dec-1991]
C-fpp- Date: Fri Jan 31 07:47:36 1992
C-fpp- Directory: /home/plot79/prim
C-fpp- User:  <beebe@eros>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _MIPS=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      INTEGER FUNCTION  CHRASC (C)
C     (ASCII Ordinal)
C     Return the ordinal  position of the  single character C  in
C     the ASCII character set.  For ASCII machines, this function
C     is identical to CHRORD, but for non-ASCII machines will  be
C     different.  If C has no ASCII graphic equivalent, then  the
C     value -1 must be returned.
C     (30-MAR-85)
      CHARACTER           C
      INTEGER             ICHAR
C
      CHRASC = ICHAR(C)
      IF ((CHRASC .LT. 0) .OR. (127 .LT. CHRASC)) CHRASC = -1
C
      RETURN
      END
      CHARACTER FUNCTION  CHRCHR (ORD)
C     (Character)
C     Return the single  character corresponding  to the  INTEGER
C     ordinal  position   ORD   in   the   installation-dependent
C     character set.   The right-most  bits in  ORD are  used  to
C     construct the character, and all remaining bits of ORD  are
C     ignored, so that no error condition exists if ORD is out of
C     the valid range.  On most machines, this will be equivalent
C     to the  FORTRAN  77  intrinsic  function  CHAR()  when  the
C     argument is in range.
C     (30-MAR-85)
      CHARACTER           CHAR
      INTEGER             AND
      INTEGER             ORD
C
C#if _HPUX
C##      CHRCHR = CHAR(IAND(ORD,255))
C#else
      CHRCHR = CHAR(AND(ORD,255))
C#endif
C
      RETURN
      END
      INTEGER FUNCTION  CHRCM2 (TEXTA,TEXTB,LENGTH)
C     (Compare Characters Ignoring Case)
C     Given two  character  strings  in  TEXTA(*)  and  TEXTB(*),
C     compare "LENGTH" characters.   Return -K,  0, or  +K for  A
C     .LT. B, A  .EQ. B, and  A .GT. B,  respectively, where  the
C     comparisons are done  using the  ASCII collating  sequence,
C     and K is the index of the first character which differs  in
C     the two strings.  If any of "LOCA", "LOCB", or "LENGTH" are
C     less than 1, CHRCM2 = 0 is returned.  Upper- and lower-case
C     letters are treated as equivalent.
C     (30-MAR-85)
      CHARACTER           CHRUC,       TEXTA(1),    TEXTB(1)
      INTEGER             CHRASC,      K,           LENGTH
C
      CHRCM2 = 0
      K = 1
      GO TO 50
C
C     DO WHILE (K .LE. LENGTH) -- put test at end to save GO TO.
C
   10 IF (CHRASC(CHRUC(TEXTA(K))) - CHRASC(CHRUC(TEXTB(K)))) 20,40,30
   20 CHRCM2 = -K
      GO TO 60
   30 CHRCM2 = +K
      GO TO 60
   40 K = K + 1
   50 IF (K .LE. LENGTH) GO TO 10
C
C     END WHILE
C
   60 RETURN
      END
      INTEGER FUNCTION  CHRCMP (TEXTA,TEXTB,LENGTH)
C     (Compare Characters)
C     Given two  character  strings  in  TEXTA(*)  and  TEXTB(*),
C     compare "LENGTH" characters.   Return -K,  0, or  +K for  A
C     .LT. B, A .EQ.  B, and A .GT.   B, respectively, where  the
C     comparisons are done  using the  ASCII collating  sequence,
C     and K is the index of the first character which differs  in
C     the two strings.  If "LENGTH" is less than 1, CHRCM2 = 0 is
C     returned.  Upper-  and lower-case  letters are  treated  as
C     distinct.
C     (30-MAR-85)
      CHARACTER           TEXTA(1),    TEXTB(1)
      INTEGER             CHRASC,      K,           LENGTH
C
      CHRCMP = 0
      K = 1
      GO TO 50
C
C     DO WHILE (K .LE. LENGTH) -- PUT TEST AT END TO SAVE GO TO.
C
   10 IF (CHRASC(TEXTA(K)) - CHRASC(TEXTB(K))) 20,40,30
   20 CHRCMP = -K
      GO TO 60
   30 CHRCMP = +K
      GO TO 60
   40 K = K + 1
   50 IF (K .LE. LENGTH) GO TO 10
C
C     END WHILE
C
   60 RETURN
      END
      SUBROUTINE  CHRCTH (HOLLER,LOC,LENGTH,TEXT)
C     (CHARACTER to Packed Hollerith)
C     Move LENGTH characters of a CHARACTER string, TEXT(*), to a
C     packed Hollerith string, HOLLER(*), beginning at  character
C     offset LOC (1, 2, 3,  ...) in HOLLER(*).  If either  LENGTH
C     or LOC is less than one, return occurs immediately with  no
C     string movement.
C     (01-APR-85)
      CHARACTER           TEXT(1)
      INTEGER             CHRORD,      HOLLER(1),   I,           KARCHR
      INTEGER             LOC,         LENGTH
C
      IF (LENGTH .LE. 0) GO TO 20
      IF (LOC .LE. 0) GO TO 20
           DO 10 I = 1,LENGTH
           CALL KARMOV (HOLLER,LOC+I-1,KARCHR(CHRORD(TEXT(I))),1,1)
   10      CONTINUE
C
   20 RETURN
      END
      SUBROUTINE  CHRHTC (TEXT,HOLLER,LOC,LENGTH)
C     (Packed Hollerith to CHARACTER)
C     Move LENGTH  characters  from a  packed  Hollerith  string,
C     HOLLER(*), beginning at character offset LOC (1, 2, 3, ...)
C     in HOLLER(*)  to a  CHARACTER string,  TEXT(*).  If  either
C     LENGTH or LOC is less  than one, return occurs  immediately
C     with no string movement.
C     (01-APR-85)
      CHARACTER           CHRCHR,      TEXT(1)
      INTEGER             H,           HOLLER(1),   I,           KARORD
      INTEGER             LENGTH,      LOC
C
      IF (LENGTH .LE. 0) GO TO 20
      IF (LOC .LE. 0) GO TO 20
           DO 10 I = 1,LENGTH
           CALL KARGET (H,HOLLER,I+LOC-1)
           TEXT(I) = CHRCHR(KARORD(H))
   10      CONTINUE
C
   20 RETURN
      END
      INTEGER FUNCTION  CHRID2 (TEXTA,LENA,TEXTB,LENB)
C     (Substring Index Ignoring Case)
C     Given  two  character  strings  defined  by  the  arguments
C     TEXT,LENA and TEXTB,LENB, search  the first string for  the
C     first occurrence of  the second string.   If either of  the
C     arguments LENA or LENB are invalid, or if the second string
C     is not found in the first, return 0.  Otherwise, return its
C     index, or  position,  in  TEXTA, counting  from  the  first
C     character stored in TEXTA(*).  The result returned is  thus
C     always .GE. 0.
C     (30-MAR-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRORD,      CHRUC
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRUC
      INTEGER             CHRORD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CHAR1,       CHARA,       CHARB,       I
C     SETS                II,          J,           LIMITA
C
      CHARACTER           TEXTA(1),    TEXTB(1)
      INTEGER             CHAR1,       CHARA,       CHARB,       I
      INTEGER             II,          J,           LENA,        LENB
      INTEGER             LIMITA
C
      CHRID2 = 0
      IF (LENA .LE. 0) GO TO 40
      IF (LENB .LE. 0) GO TO 40
      CHAR1 = CHRORD(CHRUC(TEXTB(1)))
      LIMITA = 1 + LENA - LENB
           DO 30 I = 1,LIMITA
           CHARA = CHRORD(CHRUC(TEXTA(I)))
           CHARB = CHAR1
           II = I + 1
           J = 2
           GO TO 20
C
C     DO WHILE (EQUAL AND IN SUBSTRING) -- PUT TEST AT END TO SAVE GOTO
C
   10      CHARA = CHRORD(CHRUC(TEXTA(II)))
           CHARB = CHRORD(CHRUC(TEXTB(J)))
           II = II + 1
           J = J + 1
   20      IF ((CHARA .EQ. CHARB) .AND. (J .LE. LENB)) GO TO 10
C
C     END WHILE
C
           IF (CHARA .NE. CHARB) GO TO 30
           CHRID2 = I
           GO TO 40
   30      CONTINUE
C
   40 RETURN
      END
      INTEGER FUNCTION  CHRIDX (TEXTA,LENA,TEXTB,LENB)
C     (Substring Index)
C     Given  two  character  strings  defined  by  the  arguments
C     TEXTA,LENA and TEXTB,LENB, search the first string for  the
C     first occurrence of  the second  string. If  either of  the
C     arguments LENA or LENB is invalid, or if the second  string
C     is not found in the first, return 0.  Otherwise, return its
C     index, or  position,  in  TEXTA, counting  from  the  first
C     character stored in TEXTA(*).  The result returned is  thus
C     always .GE. 0.
C     (30-MAR-85)
      CHARACTER           CHAR1,       CHARA,       CHARB
      CHARACTER           TEXTA(1),    TEXTB(1)
      INTEGER             I,           II,          J,           LENA
      INTEGER             LENB,        LIMITA
C
      CHRIDX = 0
      IF (LENA .LE. 0) GO TO 40
      IF (LENB .LE. 0) GO TO 40
      CHAR1 = TEXTB(1)
      LIMITA = 1 + LENA - LENB
           DO 30 I = 1,LIMITA
           CHARA = TEXTA(I)
           CHARB = CHAR1
           II = I + 1
           J = 2
           GO TO 20
C
C     DO WHILE (EQUAL AND IN SUBSTRING) -- PUT TEST AT END TO SAVE GOTO
C
   10      CHARA = TEXTA(II)
           CHARB = TEXTB(J)
           II = II + 1
           J = J + 1
   20      IF ((CHARA .EQ. CHARB) .AND. (J .LE. LENB)) GO TO 10
C
C     END WHILE
C
           IF (CHARA .NE. CHARB) GO TO 30
           CHRIDX = I
           GO TO 40
   30      CONTINUE
C
   40 RETURN
      END
      CHARACTER FUNCTION  CHRLC (C)
C     (Lower-case)
C     Return the lower-case equivalent of the single character C.
C     Only the  letters  "A"  -  "Z" will  be  affected  by  this
C     function.  If the host computer does not support lower-case
C     letters, then CHRLC must return C as its value.
C     (30-MAR-85)
      CHARACTER           C,           CHRLCL
      INTEGER             CHRASC,      ORD
C
      ORD = CHRASC(C)
      IF ((65 .LE. ORD) .AND. (ORD .LE. 90)) THEN
           CHRLC = CHRLCL(ORD + 32)
      ELSE
           CHRLC = C
      END IF
C
      RETURN
      END
      CHARACTER FUNCTION  CHRLCL (ASCORD)
C     (Local Character)
C     Return the  character  in  the local  character  set  which
C     corresponds to  the ASCII  character having  ordinal  value
C     "ASCORD".  Only the low-order 7  bits of "ASCORD" are  used
C     to determine an index into the local character table.
C     (30-MAR-85)
      CHARACTER           CHAR
      INTEGER             AND
      INTEGER             ASCORD
C
C     The following code is valid for those host computers  which
C     use the ASCII character set.
C
C#if _HPUX
C##      CHRLCL = CHAR(IAND(ASCORD,127))
C#else
      CHRLCL = CHAR(AND(ASCORD,127))
C#endif
C
      RETURN
      END
      INTEGER FUNCTION  CHRLEN (TEXT,LENGTH)
C     (Length)
C     Trim  trailing  blanks from TEXT(*), returning the index of
C     the last  non-blank character  in TEXT(*)  as the  function
C     value.  If the string is entirely blank, or has LENGTH .LT.
C     1, then 0 will be returned.
C     (31-Mar-85)
      CHARACTER           TEXT(1)
      INTEGER             K,           LENGTH,      MAX0
C
      K = MAX0(0,LENGTH)
      GO TO 20
   10 IF (TEXT(K) .NE. ' ') GO TO 30
      K = K - 1
   20 IF (K .GT. 0) GO TO 10
   30 CHRLEN = K
C
      RETURN
      END
      INTEGER FUNCTION  CHRMAT (TEXT,LENTXT,PATERN,LENPAT)
C     (Match Characters)
C     Search the  string defined  by  TEXT,LENTXT for  the  first
C     character which is contained in the pattern string  defined
C     by PATERN,LENPAT.  If either LENTXT or LENPAT is less  than
C     1, return 0.   If all  characters in the  first string  are
C     absent in PATERN(*), return 0.  Otherwise return the  index
C     of the first  matching character in  TEXT(*).  Thus  CHRMAT
C     always returns a value  .GE.  0.  It  is important to  note
C     that the index returned points to a character in the  first
C     string, not to one in the pattern string.
C     (01-APR-85)
      CHARACTER           PATERN(1),   TEXT(1)
      INTEGER             CHRORD,      I,           LENPAT,      LENTXT
      INTEGER             MAXINP
      LOGICAL             INPAT(256)
C
      DATA                MAXINP    / 256 /
C
      CHRMAT = 0
      IF (LENTXT .LE. 0) GO TO 40
      IF (LENPAT .LE. 0) GO TO 40
C
C     Build a lookup table.   This need only be  as large as  the
C     local  character  set;  the   remainder  of  the  code   is
C     independent of the host computer and character set.
C
           DO 10 I = 1,MAXINP
           INPAT(I) = .FALSE.
   10      CONTINUE
           DO 20 I = 1,LENPAT
           INPAT(CHRORD(PATERN(I))+1) = .TRUE.
   20      CONTINUE
C
C     Now check each character in TEXT(*) to see if it is in  the
C     pattern.
C
           DO 30 I = 1,LENTXT
           IF (.NOT.INPAT(CHRORD(TEXT(I))+1)) GO TO 30
           CHRMAT = I
           GO TO 40
   30      CONTINUE
C
   40 RETURN
      END
      SUBROUTINE  CHRMOV (TARGET,SOURCE,LENGTH)
C     (Move Characters)
C     Given two  character strings  in SOURCE(*)  and  TARGET(*),
C     move "LENGTH" characters.   If LENGTH  is less  than 1,  no
C     characters are  moved.  The  move  is effected  by  copying
C     characters from left to right from SOURCE into TARGET.   In
C     the event of overlapping SOURCE and TARGET, this can  cause
C     a fill operation.  Note that this is different than FORTRAN
C     77 CHARACTER assignment, which expressly prohibits overlap.
C     (30-MAR-85)
      CHARACTER        SOURCE(1),   TARGET(1)
      INTEGER          I,           LENGTH
C
      IF (LENGTH .LE. 0) GO TO 20
           DO 10 I = 1,LENGTH
           TARGET(I) = SOURCE(I)
   10      CONTINUE
C
   20 RETURN
      END
      INTEGER FUNCTION  CHRORD (C)
C     (Ordinal)
C     Return the ordinal  position of the  single character C  in
C     the installation-dependent  character  set.  The  value  is
C     guaranteed to lie  in the  range 0 ..   N, where  N is  the
C     number of characters representable with the number of  bits
C     allocated to a CHARACTER value on the host machine.
C
C     On most machines, this will be equivalent to the FORTRAN 77
C     intrinsic function ICHAR().  However, although the  FORTRAN
C     77 standard  requires  ICHAR()  to  return  a  non-negative
C     result for any valid character, some implementations  treat
C     bytes as signed integers,  and return negative values  -127
C     ..  -1  for positions  128 ..  255.  Others  may choose  to
C     raise an error condition if  C contains a character not  in
C     the host character set.  CHRORD will never do so.
C     (30-MAR-85)
      CHARACTER           C
      INTEGER             ICHAR
C
      CHRORD = ICHAR(C)
      IF (CHRORD .LT. 0) CHRORD = CHRORD + 256
C
      RETURN
      END
      INTEGER FUNCTION  CHRRI2 (TEXTA,LENA,TEXTB,LENB)
C     (Reverse Substring Index Ignoring Case)
C     Given  two  character  strings  defined  by  the  arguments
C     TEXT,LENA and TEXTB,LENB, search the first string  backward
C     for the last occurrence of the second string.  If either of
C     the arguments LENA or  LENB are invalid,  or if the  second
C     string is not  found in  the first,  return 0.   Otherwise,
C     return its index, or position, in TEXTA, counting from  the
C     first character stored in TEXTA(*).  The result returned is
C     thus always .GE. 0.
C     (01-APR-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRORD,      CHRUC
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRUC
      INTEGER             CHRORD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CHAR1,       CHARA,       CHARB,       I
C     SETS                II,          J,           LIMITA
C
      CHARACTER           TEXTA(1),    TEXTB(1)
      INTEGER             CHAR1,       CHARA,       CHARB,       I
      INTEGER             II,          J,           LENA,        LENB
      INTEGER             LIMITA
C
      CHRRI2 = 0
      IF (LENA .LE. 0) GO TO 40
      IF (LENB .LE. 0) GO TO 40
      IF (LENB .GT. LENA) GO TO 40
      CHAR1 = CHRORD(CHRUC(TEXTB(1)))
      LIMITA = 1 + LENA - LENB
           DO 30 I = LIMITA,1,-1
           CHARA = CHRORD(CHRUC(TEXTA(I)))
           CHARB = CHAR1
           II = I + 1
           J = 2
           GO TO 20
C
C     DO WHILE (EQUAL AND IN SUBSTRING) -- PUT TEST AT END TO SAVE GOTO
C
   10      CHARA = CHRORD(CHRUC(TEXTA(II)))
           CHARB = CHRORD(CHRUC(TEXTB(J)))
           II = II + 1
           J = J + 1
   20      IF ((CHARA .EQ. CHARB) .AND. (J .LE. LENB)) GO TO 10
C
C     END WHILE
C
           IF (CHARA .NE. CHARB) GO TO 30
           CHRRI2 = I
           GO TO 40
   30      CONTINUE
C
   40 RETURN
      END
      INTEGER FUNCTION  CHRRIX (TEXTA,LENA,TEXTB,LENB)
C     (Reverse Substring Index)
C     Given  two  character  strings  defined  by  the  arguments
C     TEXTA,LENA  and   TEXTB,LENB,  search   the  first   string
C     backwards for the last occurrence of the second string.  If
C     either of the arguments LENA or LENB is invalid, or if  the
C     second  string  is  not  found  in  the  first,  return  0.
C     Otherwise,  return  its  index,  or  position,  in   TEXTA,
C     counting from the first character stored in TEXTA(*).   The
C     result returned is thus always .GE. 0.
C     (30-MAR-85)
      CHARACTER           CHAR1,       CHARA,       CHARB
      CHARACTER           TEXTA(1),    TEXTB(1)
      INTEGER             I,           II,          J,           LENA
      INTEGER             LENB,        LIMITA
C
      CHRRIX = 0
      IF (LENA .LE. 0) GO TO 40
      IF (LENB .LE. 0) GO TO 40
      IF (LENB .GT. LENA) GO TO 40
      CHAR1 = TEXTB(1)
      LIMITA = 1 + LENA - LENB
           DO 30 I = LIMITA,1,-1
           CHARA = TEXTA(I)
           CHARB = CHAR1
           II = I + 1
           J = 2
           GO TO 20
C
C     DO WHILE (EQUAL AND IN SUBSTRING) -- PUT TEST AT END TO SAVE GOTO
C
   10      CHARA = TEXTA(II)
           CHARB = TEXTB(J)
           II = II + 1
           J = J + 1
   20      IF ((CHARA .EQ. CHARB) .AND. (J .LE. LENB)) GO TO 10
C
C     END WHILE
C
           IF (CHARA .NE. CHARB) GO TO 30
           CHRRIX = I
           GO TO 40
   30      CONTINUE
C
   40 RETURN
      END
      SUBROUTINE  CHRSWP (TEXTA,TEXTB,LENGTH)
C     (Swap Characters)
C     Given two character strings in TEXTA(*) and TEXTB(*),  swap
C     "LENGTH" characters.   If  "LENGTH"  is  less  than  1,  no
C     characters are swapped.
C     (30-MAR-85)
      CHARACTER           TEXTA(1),    TEXTB(1),    C
      INTEGER             I,           LENGTH
C
      IF (LENGTH .LE. 0) GO TO 20
           DO 10 I = 1,LENGTH
           C = TEXTA(I)
           TEXTA(I) = TEXTB(I)
           TEXTB(I) = C
   10      CONTINUE
C
   20 RETURN
      END
      CHARACTER FUNCTION  CHRUC (C)
C     (Upper-case)
C     Return the upper-case equivalent of the single character C.
C     Only the  letters  "a"  -  "z" will  be  affected  by  this
C     function.  If the host computer does not support upper-case
C     letters, then CHRLC must return C as its value.
C     (30-MAR-85)
      CHARACTER           C,           CHRLCL
      INTEGER             ORD,         CHRASC
C
      ORD = CHRASC(C)
      IF ((97 .LE. ORD) .AND. (ORD .LE. 122)) THEN
           CHRUC = CHRLCL(ORD - 32)
      ELSE
           CHRUC = C
      END IF
C
      RETURN
      END
      INTEGER FUNCTION  CHRVFY (TEXT,LENTXT,PATERN,LENPAT)
C     (Verify Characters)
C     Search the  string defined  by  TEXT,LENTXT for  the  first
C     character which  is not  contained  in the  pattern  string
C     defined by PATERN,LENPAT.   If either LENTXT  or LENPAT  is
C     less than  1, return  0.  If  all characters  in the  first
C     string are found in PATERN(*), return 0.  Otherwise  return
C     the index of  the first mismatching  character in  TEXT(*).
C     Thus  CHRVFY  always  returns  a  value  .GE.   0.   It  is
C     important to  note  that the  index  returned points  to  a
C     character in the first  string, not to  one in the  pattern
C     string.
C     (30-MAR-85)
      CHARACTER           PATERN(1),   TEXT(1)
      INTEGER             CHRORD,      I,           LENPAT,      LENTXT
      INTEGER             MAXINP
      LOGICAL             INPAT(256)
C
      DATA                MAXINP    / 256 /
C
      CHRVFY = 0
      IF (LENTXT .LE. 0) GO TO 40
      IF (LENPAT .LE. 0) GO TO 40
C
C     Build a lookup table.   This need only be  as large as  the
C     local  character  set;  the   remainder  of  the  code   is
C     independent of the host computer and character set.
C
           DO 10 I = 1,MAXINP
           INPAT(I) = .FALSE.
   10      CONTINUE
           DO 20 I = 1,LENPAT
           INPAT(CHRORD(PATERN(I))+1) = .TRUE.
   20      CONTINUE
C
C     Now check each character in TEXT(*) to see if it is in  the
C     pattern.
C
           DO 30 I = 1,LENTXT
           IF (INPAT(CHRORD(TEXT(I))+1)) GO TO 30
           CHRVFY = I
           GO TO 40
   30      CONTINUE
C
   40 RETURN
      END
      SUBROUTINE  CHRXLT (TEXT,LENTXT,OLD,NEW,LENSUB)
C     (Translate Characters)
C     Given  a  character  string  defined  by  "TEXT(*),LENTXT",
C     translate characters according to  the replacements in  the
C     strings "OLD,LENSUB" and "NEW,LENSUB".  If either LENTXT or
C     LENSUB is less  than 1, return  occurs immediately with  no
C     action taken.
C
C     Each character  occurring  in OLD(*)  has  a  corresponding
C     character in NEW(*).  For example, the statement
C
C     CALL CHRXLT (TEXT,LENTXT, '<>', '()', 2)
C
C     will result  in  each  occurrence of  <  in  TEXT(*)  being
C     translated to (, and each > to ).
C
C     The characters in OLD(*) should be unique. In case they are
C     not,  the  translation  MUST  be  according  to  the   last
C     occurrence of a duplicated  character.  That is, if  OLD(*)
C     contains 'BAB' and NEW(*) contains  'XYZ', then A's in  the
C     substring will be translated to Y's, and B's to Z's.   This
C     restriction facilitates implementation  of the  translation
C     with an internal lookup table constructed from the standard
C     character set with  changes according  to substitutions  of
C     OLD characters with NEW characters performed in order  from
C     left to right.
C     (30-MAR-85)
      CHARACTER           CHRCHR,      NEW(1),      OLD(1),      TEXT(1)
      INTEGER             CHRORD,      I,           LENSUB,      LENTXT
      INTEGER             LOCAL(256),  MAXLOC
C
      DATA                MAXLOC    / 256 /
C
      IF (LENTXT .LE. 0) GO TO 40
      IF (LENSUB .LE. 0) GO TO 40
C
C     Build a lookup table.   This need only be  as large as  the
C     local  character  set;  the   remainder  of  the  code   is
C     independent of the host computer and character set.
C
           DO 10 I = 1,MAXLOC
           LOCAL(I) = I-1
   10      CONTINUE
           DO 20 I = 1,LENSUB
           LOCAL(CHRORD(OLD(I))+1) = CHRORD(NEW(I))
   20      CONTINUE
C
C     Now use  the  lookup table  to  replace each  character  in
C     TEXT(*).
C
           DO 30 I = 1,LENTXT
           TEXT(I) = CHRCHR(LOCAL(CHRORD(TEXT(I))+1))
   30      CONTINUE
C
   40 RETURN
      END
