      SUBROUTINE  CLOCKS (N)
C     (Clock Routine)
C     CALL CLOCK(1) starts the timer.
C     CALL CLOCK(2) stops the timer and prints timing statistics.
C     Other system statistics may also be accumulated and printed
C     if available.
C     (26-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       DEMAND,      FLOAT,       IFIX,        SECOND
C     EXTERNAL REFS       SYSGPI,      SYSLOG
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             DEMAND
      REAL                SECOND
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             IFIX
      REAL                FLOAT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                LENLST,      LIST,        LOGFIL,      NFALT1
C     SETS                NTRAP1,      PCTPGT,      PGTIM1,      RATFT
C     SETS                RATNFA,      RATNTR,      TIN,         TTOTAL
C
      INTEGER             JUNK,        LENLST,      LIST(4),     LOGFIL
      INTEGER             N,           NFALT0,      NFALT1,      NTRAP0
      INTEGER             NTRAP1
      REAL                PCTPGT,      PGTIM0,      PGTIM1,      RATFT
      REAL                RATNFA,      RATNTR,      TIN,         TTOTAL
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM06  /
C
      INTEGER             F4KEY,       HOLDIO,      INSF,        LINE
      INTEGER             LINENO,      MAXIN,       MDATA,       OUTERR
      INTEGER             OUTF4,       OUTSF,       P2BASE,      PBASE
      INTEGER             SBASE,       SFKEY,       SPACES,      TEMPF4
      LOGICAL             ERRORS
      COMMON / COM06  /   ERRORS,      F4KEY,       HOLDIO,      INSF
      COMMON / COM06  /   LINE,        LINENO,      MAXIN,       MDATA
      COMMON / COM06  /   OUTERR,      OUTF4,       OUTSF,       P2BASE
      COMMON / COM06  /   PBASE,       SBASE,       SFKEY,       SPACES
      COMMON / COM06  /   TEMPF4
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM18  /
C
      LOGICAL             DEBUG,       NOSFL,       PRETTY
C
      COMMON / COM18  /   DEBUG,       NOSFL,       PRETTY
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM21  /
C
      INTEGER             NPROBE,      NSRCH,       NCOMP,       NSUCC
      INTEGER             NFAIL
C
      COMMON / COM21  /   NPROBE,      NSRCH,       NCOMP,       NSUCC
      COMMON / COM21  /   NFAIL
C
C
      DATA                LENLST    / 4 /
C
      NX0003=N
      IF (NX0003.LT.1.OR.NX0003.GT.2) GO TO 20003
      GO TO (20001,20002), NX0003
20001 TIN = SECOND(TIN)
      CALL SYSGPI (NTRAP0,NFALT0,PGTIM0)
      ASSIGN 20005 TO NPR001
      GO TO 30001
20005 GO TO 20004
20002 ASSIGN 20006 TO NPR002
      GO TO 30002
20006 IF (.NOT.(.NOT.PRETTY .AND. .NOT.NOSFL)) GO TO 20007
      LOGFIL = OUTSF
C               DO (Write Statistics)
20007 CONTINUE
20008 IF (.NOT.(.NOT.DEMAND(JUNK) .AND. (OUTSF .NE. OUTERR))) GO TO 2001
     X0
      LOGFIL = OUTERR
C               DO (Write Statistics)
20010 ASSIGN 20013 TO NPR003
      GO TO 30003
20013 CONTINUE
20003 CONTINUE
C
20004 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Compute Statistics)
30002 CALL SYSGPI (NTRAP1,NFALT1,PGTIM1)
      NTRAP1 = NTRAP1 - NTRAP0
      NFALT1 = NFALT1 - NFALT0
      PGTIM1 = PGTIM1 - PGTIM0
      TTOTAL = SECOND(TTOTAL) - TIN
      IF (NFALT1 .LE. 0) NFALT1 = 1
      IF (NTRAP1 .LE. 0) NTRAP1 = 1
      IF (TTOTAL .LE. 0.0) TTOTAL = 1.0
      RATNTR = FLOAT(NTRAP1)/TTOTAL
      RATNFA = FLOAT(NFALT1)/TTOTAL
      RATFT = RATNFA/RATNTR
      PCTPGT = 100.0*PGTIM1/TTOTAL
      GO TO 20006
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Initialize Statistics)
30001 NPROBE = 0
      NSRCH = 0
      NCOMP = 0
      NSUCC = 0
      NFAIL = 0
      GO TO 20005
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Write Statistics)
30004 IF (.NOT.(LOGFIL .GT. 0)) GO TO 20014
      WRITE (LOGFIL,1000) TTOTAL
      WRITE (LOGFIL,2000) PGTIM1,PCTPGT
      WRITE (LOGFIL,3000) NTRAP1,RATNTR
      WRITE (LOGFIL,4000) NFALT1,RATNFA
      WRITE (LOGFIL,5000) RATFT
      WRITE (LOGFIL,6000) NPROBE,NSRCH,NCOMP,NSUCC,NFAIL
20014 CONTINUE
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Write System Log File)
30003 LIST(1) = IFIX(1000.0*TTOTAL)
      LIST(2) = IFIX(1000.0*PGTIM1)
      LIST(3) = NTRAP1
      LIST(4) = NFALT1
      CALL SYSLOG (LIST,LENLST)
      GO TO 20013
C
 1000 FORMAT (//27H *** SFTRAN3 Statistics ***/ 13H CPU Time    ,F10.3,
     X6H (sec))
 2000 FORMAT (13H Page Time   ,F10.3,6H (sec),F10.2,6H % CPU)
 3000 FORMAT (13H Page Traps  ,I10,F16.2,4H/sec)
 4000 FORMAT (13H Page Faults ,I10,F16.2,4H/sec)
 5000 FORMAT (13H Faults/Traps,F10.2)
 6000 FORMAT (13H Hash Probes ,I10/
     X13H Searches    ,I10/
     X13H Compares    ,I10/
     X13H Success     ,I10/
     X13H Failure     ,I10)
      END
