      SUBROUTINE  SRCHHT (STRING,FIRST,LENSTR,HASHTB,LOCHTB,CASEID)
C     (Search Hash Table)
C     Given a  substring  of  "LENSTR"  characters  beginning  at
C     position "FIRST" in  STRING(*), search for  it in the  hash
C     table  defined  by  "HASHTB(*)".   On  return,  the  output
C     parameters are as follows:
C
C     LOCHTB........Index in HASHTB(*) of last entry found.  This
C                   will be the requested entry if the string was
C                   found, or may be the  index of the last  link
C                   in a chain.
C     CASEID........String identifier integer, or null if not found.
C
C     (30-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3,      F4CLC,       MOD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
      LOGICAL             F4CLC
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MOD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CASEID,      FNDSTR,      HASH,        K
C     SETS                LOCHTB,      NULL
C
      INTEGER             CASEID,      FIRST,       HASH
      INTEGER             HASHTB(1),   K,           LENSTR,      LOCHTB
      INTEGER             NULL,        STRING(1)
      LOGICAL             FNDSTR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM21  /
C
      INTEGER             NPROBE,      NSRCH,       NCOMP,       NSUCC
      INTEGER             NFAIL
C
      COMMON / COM21  /   NPROBE,      NSRCH,       NCOMP,       NSUCC
      COMMON / COM21  /   NFAIL
C
C
C
C     Element defining a null link  in a list.  Any  non-positive
C     value could be used.
C
      DATA                NULL      / 0 /
C
      NPROBE = NPROBE + 1
      HASH = 0
      K =FIRST
      N20001=FIRST+LENSTR-1
      GO TO 20002
20001 K =K +1
20002 IF ((N20001-K ).LT.0) GO TO 20003
      HASH = HASH + CHGET3(STRING,K)
      GO TO 20001
20003 HASH = 4 + MOD(HASH,HASHTB(1))
      LOCHTB = HASH
      FNDSTR = .FALSE.
      K = HASHTB(HASH)
      CASEID = NULL
20005 IF (.NOT.((K .NE. NULL) .AND. .NOT.FNDSTR)) GO TO 20006
      NSRCH = NSRCH + 1
      IF (.NOT.(LENSTR .EQ. HASHTB(K+2))) GO TO 20007
      FNDSTR = F4CLC(HASHTB(K+3),1,STRING,FIRST,LENSTR)
      NCOMP = NCOMP + 1
      IF (.NOT.(FNDSTR)) GO TO 20010
      NSUCC = NSUCC + 1
      GO TO 20011
20010 NFAIL = NFAIL + 1
20011 CONTINUE
20012 CONTINUE
20007 CONTINUE
20008 LOCHTB = K
      IF (FNDSTR) CASEID = HASHTB(K+1)
      K = HASHTB(K)
      GO TO 20005
C
20006 RETURN
      END
